﻿#define DEBUG_AGENT

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using System.IO;
using System.ServiceModel.Syndication;
using System.Xml;
using System.Text.RegularExpressions;
using Microsoft.Phone.Shell;
using Microsoft.Phone.Scheduler;

namespace FeedTile
{
    public partial class MainPage : PhoneApplicationPage
    {
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            Refresh();
        }

        public void Refresh()
        {
            this.DataContext = null;
            WebClient cli = new WebClient();
            Uri u = new Uri("http://www3.nhk.or.jp/rss/news/cat0.xml");
            cli.DownloadStringCompleted += (s, e) =>
            {
                if (e.Error == null)
                {
                    //RSSの読み込みとXMLへの変換
                    StringReader sr = new StringReader(e.Result);
                    XmlReader xr = XmlReader.Create(sr);
                    SyndicationFeed sf = SyndicationFeed.Load(xr);
                    //listbox のソース情報として提供
                    this.DataContext = sf;
                }
            };
            cli.DownloadStringAsync(u);
        }

        PeriodicTask periodicTask;
        string periodicTaskName = "FeedAgent";

        private void startSchedule_Click(object sender, EventArgs e)
        {
            StartAgent();
        }

        private void stopSchedule_Click(object sender, EventArgs e)
        {
            RemoveAgent();
        }

        private void StartAgent()
        {
            //スケジュールタスクをいったん削除
            RemoveAgent();

            //スケジュールタスクの作成：タスクの名称と説明
            periodicTask = new PeriodicTask(periodicTaskName);
            periodicTask.Description = "最新のRSS Feedをタイルに表示するタスクです";

            try
            {
                //スケジュールタスクを登録して起動を待つ
                ScheduledActionService.Add(periodicTask);
#if(DEBUG_AGENT)
                // デバッグ時は60秒に1度Agent が起動する
                ScheduledActionService.LaunchForTest(periodicTaskName, TimeSpan.FromSeconds(60));
#endif
            }
            catch
            {
            }
        }

        private void RemoveAgent()
        {
            try
            {
                ScheduledActionService.Remove(periodicTaskName);
            }
            catch (Exception)
            {
            }
        }
    }
}